"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.fs = exports.FileSystem = exports.Constants = void 0;
var fs_1 = __importDefault(require("fs"));
var glob_1 = __importDefault(require("glob"));
var path_1 = __importDefault(require("path"));
var mkdirp_1 = __importDefault(require("mkdirp"));
exports.Constants = fs_1.default.constants;
var FileSystem = /** @class */ (function () {
    function FileSystem(fs) {
        this.fs = fs;
    }
    FileSystem.prototype.append = function (path, data, throws) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this.fs.writeFile(path, data, function (error) {
                if (error && throws) {
                    reject(error);
                }
                else {
                    resolve(error ? false : true);
                }
            });
        });
    };
    FileSystem.prototype.basename = function (path, ext) {
        if (ext === false) {
            return path_1.default.basename(path, path_1.default.extname(path));
        }
        return path_1.default.basename(path, ext === true ? undefined : ext);
    };
    FileSystem.prototype.chmod = function (path, mode) {
        return new Promise(function (resolve, reject) {
            fs_1.default.chmod(path, mode, function (error) {
                if (error) {
                    reject(error);
                }
                else {
                    resolve();
                }
            });
        });
    };
    FileSystem.prototype.close = function (fd, throws) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this.fs.close(fd, function (error) {
                if (error && throws) {
                    reject(error);
                }
                else {
                    resolve(error ? false : true);
                }
            });
        });
    };
    FileSystem.prototype.delete = function (path, throws) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this.fs.unlink(path, function (error) {
                if (error && throws) {
                    reject(error);
                }
                else if (error) {
                    resolve(false);
                }
                else {
                    resolve(true);
                }
            });
        });
    };
    FileSystem.prototype.dirname = function (filepath) {
        return path_1.default.dirname(filepath);
    };
    FileSystem.prototype.exists = function (path, throws, mode) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this.fs.access(path, mode, function (error) {
                if (error && throws) {
                    reject(error);
                }
                else {
                    resolve(error ? false : true);
                }
            });
        });
    };
    FileSystem.prototype.ext = function (filename) {
        return path_1.default.extname(filename);
    };
    FileSystem.prototype.file = function (path, content, throws) {
        return __awaiter(this, void 0, void 0, function () {
            var dirname;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        dirname = this.dirname(path);
                        return [4 /*yield*/, this.exists(dirname, throws)];
                    case 1:
                        if (!((_a.sent()) === false)) return [3 /*break*/, 3];
                        return [4 /*yield*/, this.mkdirp(dirname)];
                    case 2:
                        _a.sent();
                        _a.label = 3;
                    case 3: return [2 /*return*/, new Promise(function (resolve, reject) {
                            _this.fs.writeFile(path, content, function (error) {
                                if (error && throws) {
                                    reject(false);
                                }
                                else {
                                    resolve(error ? false : true);
                                }
                            });
                        })];
                }
            });
        });
    };
    FileSystem.prototype.glob = function (pattern, cwd) {
        var patternstr = cwd ? this.join(cwd, pattern) : pattern;
        return new Promise(function (resolve, reject) {
            glob_1.default(patternstr, function (error, matches) {
                if (error) {
                    reject(error);
                }
                else {
                    resolve(matches);
                }
            });
        });
    };
    FileSystem.prototype.globs = function (patterns, cwd) {
        return __awaiter(this, void 0, void 0, function () {
            var resolved;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, Promise.all(patterns.map(function (pattern) { return _this.glob(pattern, cwd); }))];
                    case 1:
                        resolved = _a.sent();
                        return [2 /*return*/, resolved.reduce(function (results, current) { return results.concat(current); }, [])];
                }
            });
        });
    };
    FileSystem.prototype.list = function (path) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this.fs.readdir(path, function (error, files) {
                /** istanbul ignore next */
                if (error) {
                    reject(error);
                }
                else {
                    resolve(files);
                }
            });
        });
    };
    FileSystem.prototype.info = function (path) {
        return this.stat(path);
    };
    FileSystem.prototype.join = function () {
        var paths = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            paths[_i] = arguments[_i];
        }
        return path_1.default.join.apply(path_1.default, paths);
    };
    FileSystem.prototype.json = function (path) {
        return __awaiter(this, void 0, void 0, function () {
            var text;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.text(path)];
                    case 1:
                        text = _a.sent();
                        if (text) {
                            return [2 /*return*/, JSON.parse(text)];
                        }
                        return [2 /*return*/, Promise.reject(text)];
                }
            });
        });
    };
    FileSystem.prototype.mkdir = function (path, mode, throws) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this.fs.mkdir(path, mode, function (error) {
                if (error && throws) {
                    reject(error);
                }
                else {
                    resolve(error ? false : true);
                }
            });
        });
    };
    FileSystem.prototype.mkdirs = function (paths, mode, throws) {
        var _this = this;
        return Promise.all(paths.map(function (path) { return _this.mkdir(path, mode, throws); })).then(function (promises) {
            return promises.reduce(function (result, current) { return (result ? result : current); }, false);
        });
    };
    FileSystem.prototype.mkdirp = function (path, throws) {
        return mkdirp_1.default(path);
    };
    FileSystem.prototype.mkdirps = function (paths, throws) {
        var _this = this;
        return Promise.all(paths.map(function (path) { return _this.mkdirp(path, throws); }));
    };
    FileSystem.prototype.open = function (path, flags, mode) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this.fs.open(path, flags, mode, function (error, fd) {
                if (error) {
                    reject(error);
                }
                else {
                    resolve(fd);
                }
            });
        });
    };
    FileSystem.prototype.read = function (fd, buffer, offset, length, position) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this.fs.read(fd, buffer, offset, length, position, function (error, data) {
                if (error) {
                    reject(error);
                }
                else {
                    resolve(data);
                }
            });
        });
    };
    FileSystem.prototype.readFile = function (path) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this.fs.readFile(path, function (error, buffer) {
                if (error) {
                    reject(error);
                }
                else {
                    resolve(buffer);
                }
            });
        });
    };
    FileSystem.prototype.relative = function (from, to) {
        return path_1.default.relative(from, to);
    };
    FileSystem.prototype.relativeFrom = function (to) {
        return path_1.default.relative(process.cwd(), to);
    };
    FileSystem.prototype.rename = function (original, filename, throws) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this.fs.rename(original, filename, function (error) {
                if (error && throws) {
                    reject(error);
                }
                else {
                    resolve(error ? false : true);
                }
            });
        });
    };
    FileSystem.prototype.resolve = function () {
        var paths = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            paths[_i] = arguments[_i];
        }
        return path_1.default.resolve.apply(path_1.default, paths);
    };
    FileSystem.prototype.save = function (path, object, throws) {
        return __awaiter(this, void 0, void 0, function () {
            var dirname;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        dirname = this.dirname(path);
                        return [4 /*yield*/, this.exists(dirname, throws)];
                    case 1:
                        if (!((_a.sent()) === false)) return [3 /*break*/, 3];
                        return [4 /*yield*/, this.mkdirp(dirname)];
                    case 2:
                        _a.sent();
                        _a.label = 3;
                    case 3: return [2 /*return*/, new Promise(function (resolve, reject) {
                            _this.fs.writeFile(path, JSON.stringify(object), function (error) {
                                if (error && throws) {
                                    reject(false);
                                }
                                else {
                                    resolve(error ? false : true);
                                }
                            });
                        })];
                }
            });
        });
    };
    FileSystem.prototype.stat = function (path) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this.fs.stat(path, function (error, stats) {
                if (error) {
                    reject(error);
                }
                else {
                    resolve({ path: String(path), stats: stats });
                }
            });
        });
    };
    FileSystem.prototype.stats = function () {
        var _this = this;
        var paths = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            paths[_i] = arguments[_i];
        }
        return Promise.all(paths.map(function (path) { return _this.stat(path); }));
    };
    FileSystem.prototype.text = function (path) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this.fs.readFile(path, function (error, data) {
                if (error) {
                    reject(error);
                }
                else if (data) {
                    resolve(data.toString());
                }
                else {
                    resolve(undefined);
                }
            });
        });
    };
    FileSystem.prototype.write = function (fd, buffer, offset, length, position) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this.fs.write(fd, buffer, offset, length, position, function (error, written) {
                if (error) {
                    reject(error);
                }
                else {
                    resolve(written);
                }
            });
        });
    };
    FileSystem.prototype.writeFile = function (path, data) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this.fs.writeFile(path, data, function (error) {
                if (error) {
                    reject(error);
                }
                else {
                    resolve();
                }
            });
        });
    };
    return FileSystem;
}());
exports.FileSystem = FileSystem;
exports.fs = new FileSystem(fs_1.default);
//# sourceMappingURL=FileSystem.js.map